#version 330

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 worldNormal;
out vec2 fragmentUV;

uniform mat4 modelMatrix;
uniform mat4 PV;

void main()
{
	fragmentUV = uv;
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	gl_Position = PV * modelMatrix * vec4(position, 1);
}