#version 330

in vec3 normalViewSpace;
in vec3 positionViewSpace;
in vec3 lightVectorViewSpace;

out vec4 fragColor;

void main()
{
	vec3 normal = normalize(normalViewSpace);

	float ambient = 0.1;

	vec3 light_color = vec3(0.498, 0.282, 0.682);

	vec3 lightVecN = normalize(lightVectorViewSpace);

	// diffuse term could be negative
	vec3 diffuse = max(0.0, dot(normal, lightVecN)) * light_color;
	
	// specular term
	float shininess = 30.0;
	vec3 viewVector = normalize(-positionViewSpace);
	vec3 reflectedViewVec = reflect(viewVector, normal);
	float specularAmount = max(0.0, dot(lightVecN, -reflectedViewVec));
	vec3 specular = pow(specularAmount, shininess) * vec3(1.0, 1.0, 1.0);

	fragColor = vec4(ambient + diffuse + specular, 1.0);

	// debug: just show normals
	// fragColor = vec4(normal, 1.0);
}